/*
GNU General Public License version 3 notice

Copyright (C) 2012 Mihawk <luiz@netdome.biz>. All rights reserved.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see < http://www.gnu.org/licenses/ >.
*/

#ifndef SETTINGS_H
#define SETTINGS_H

class QSettings;
class QString;
class QStringList;

class Settings
{
public:
  static Settings*  globalInstance();

  QStringList       serverList();
  void              setServerList(QStringList& list);
  QString           quakeFolder() const;

  QString           botName() const;
  int               botPing() const;
  int               botTopColor() const;
  int               botBottomColor() const;
  bool              botSpectator() const;
  int               floodProtTime() const;
  int               qwFloodProtTime() const;
  int               spamFloodProtTime() const;
  unsigned int      queryInterval() const;
  int               timeToSayHiAfterConnected() const;
  int               timeToWaitForCountReply() const;
  bool              developerMode() const;

  void              save();

private:
  static Settings*  ourInstance;
  static QSettings* ourSettings;

  Settings();
  ~Settings();
  Settings(Settings&) {}
};

#endif // SETTINGS_H
